<%@  page pageEncoding="utf-8" contentType="text/html;charset=utf-8" import="com.novell.webaccess.common.JSPConduit, com.novell.emframe.dev.eMFrameUtils" %>
<%@ taglib uri="/WEB-INF/iman.tld" prefix="iman" %>
<iman:stringtable bundle="com.novell.naudit.reports.NAuditReportsResources" />

function Product(name, id)
{
	//values
	this.name = name;
	this.id = id;
	this.events = new Array();
	
	this.addEvent = addEvent;
	this.getName = getName;
	this.getID = getID;
	this.getEvent = getEvent;
	this.getEvents = getEvents;
	
	//static fields for empty fields
	this.genericFields = new Array("<iman:string key="NAR_EVENTID_DISPLAY_NAME"/>", "", "<iman:string key="NAR_SEVERITY_DISPLAY_NAME"/>", "<iman:string key="NAR_COMPONENT_DISPLAY_NAME"/>", "<iman:string key="NAR_ORIGINATOR_DISPLAY_NAME"/>", "<iman:string key="NAR_ORIGINATORTYPE_DISPLAY_NAME"/>", "<iman:string key="NAR_TARGET_DISPLAY_NAME"/>", "<iman:string key="NAR_TARGETTYPE_DISPLAY_NAME"/>", "<iman:string key="NAR_SUBTARGET_DISPLAY_NAME"/>", "<iman:string key="NAR_TEXT1_DISPLAY_NAME"/>", "<iman:string key="NAR_TEXT2_DISPLAY_NAME"/>", "<iman:string key="NAR_TEXT3_DISPLAY_NAME"/>", "<iman:string key="NAR_VALUE1_DISPLAY_NAME"/>", "<iman:string key="NAR_VALUE2_DISPLAY_NAME"/>", "<iman:string key="NAR_VALUE3_DISPLAY_NAME"/>", "<iman:string key="NAR_DATA_DISPLAY_NAME"/>", "<iman:string key="NAR_GROUP_DISPLAY_NAME"/>", "<iman:string key="NAR_SOURCEIP_DISPLAY_NAME"/>");
}

function getName()
{
	return this.name;
}

function getID()
{
	return this.id;
}

//event is an array of event descriptions from the lsc
//where the eventId is first 
function addEvent(event)
{
	this.events.push(event);
}

//find an event in the product events by ID
function getEvent(event)
{
	for(var i = 0; i < this.events.length; i++)
	{
		if(this.events[i][0] == event)
		{
			return this.events[i];
		}
	}
	
	return null;
}

function getEvents()
{
	return this.events;
}


//functions for creating dynamic select for the events list
function createProductSelect(parent, selectedEvent)
{
	var select = document.createElement("select");
	var productSelected = false;
	select.setAttribute("id", "product");
	select.setAttribute("name", "product");
	select.onchange = new Function("changeEventOptions(this.parentNode);");
	for(var i = 0; i < productList.length; i++)
	{
		var option = document.createElement("option");
		option.innerHTML = productList[i].getName();
		option.value = productList[i].getID();
		
		if(selectedEvent && (((productList[i].getID() + "0000") *1) <= selectedEvent) && (((productList[i].getID() + "FFFF") *1) >= selectedEvent))
		{
			option.selected = true;
			productSelected = true;
		}
		else if(selectedEvent && !productSelected && productList[i].getID() == "-1")
		{
			option.selected = true;
		}
		
		select.appendChild(option, false);
	}
	
	parent.appendChild(select);
}

function getChildField(parent, name)
{
	var type = "select";
	var args = getChildField.arguments;
	if(args.length >= 3)
	{
		type = args[2];
	}
	
	var selects = parent.getElementsByTagName(type);
	for(var i = 0; i < selects.length; i++)
	{
		if(selects[i].name == name)
		{
			return selects[i];
		}
	}
	
	return null;
}

function createEventSelect(parent, selectedEvent)
{	
	//find the product from the list
	var product;
	//var find = parent.getElementByName("product");//document.getElementById("product");
	var find = getChildField(parent, "product");
	
	if(!find)
	{
		alert("couldn't find child select");
		return;
	}
	
	//retrieve the lsc schema for this product from the list
	for(var i = 0; i < productList.length; i++)
	{
		if(productList[i].getID() == find.value)
		{
			product = productList[i];
			break;
		}
	}
	
	if(!product)
	{
		alert("couldn't find product");
		return;		
	}
	
	if(product.getID() == "-1")
	{
		var eventText = document.createElement("input");
		eventText.type = "text"
		eventText.name = "FirstArgument";
		eventText.value = selectedEvent;
		parent.appendChild(eventText);
		return;
	}
	
	//create select of events
	var eventSelect = document.createElement("select");
	eventSelect.setAttribute("id", "FirstArgument");
	eventSelect.setAttribute("name", "FirstArgument");
	
	var events = product.getEvents();
	for(var i = 0; i < events.length; i++)
	{
		var option = document.createElement("option");
		option.setAttribute("value",events[i][0]); 
		option.innerHTML = events[i][1];
		eventSelect.appendChild(option, false);
		if(selectedEvent && ((events[i][0]*1) == selectedEvent))
		{
			option.selected = true;
		}
	}
	
	parent.appendChild(eventSelect);
}

function changeEventOptions(parent)
{
	//find the product from the list
	var product;
	//var find = parent.getElementByName("product");//document.getElementById("product");
	var find = getChildField(parent, "product");
	
	if(!find)
	{
		alert("couldn't find child select");
		return;
	}
	
	//retrieve the lsc schema for this product from the list
	for(var i = 0; i < productList.length; i++)
	{
		if(productList[i].getID() == find.value)
		{
			product = productList[i];
			break;
		}
	}
	
	if(!product)
	{
		alert("couldn't find product");
		return;		
	}
	
	
	if(product.getID() == "-1")
	{
		var eventText = document.createElement("input");
		eventText.type = "text"
		eventText.name = "FirstArgument";
		eventText.id = "FirstArgument";
		
		//remove old select
		parent.removeChild(getChildField(parent, "FirstArgument"));
		parent.appendChild(eventText);
		return;
	}
	
	//create select of events
	var eventSelect = getChildField(parent, "FirstArgument");
	if(!eventSelect)
	{
		//look for the text field
		var eventText = getChildField(parent, "FirstArgument", "input");
		if(eventText)
		{
			parent.removeChild(eventText);
		}
		
		eventSelect = document.createElement("select");
		eventSelect.setAttribute("id", "FirstArgument");
		eventSelect.setAttribute("name", "FirstArgument");
		parent.appendChild(eventSelect);
	}
	
	
	clearSelect(eventSelect);
	
	var events = product.getEvents();
	for(var i = 0; i < events.length; i++)
	{
		var option = document.createElement("option");
		option.setAttribute("value",events[i][0]); 
		option.innerHTML = events[i][1];
		eventSelect.appendChild(option, false);
	}
}

function createConditionSelect(table, eventRow)
{
	var product;
	
	//get product from list
	var find = getChildField(table.rows[eventRow], "product");
	for(var i = 0; i < productList.length; i++)
	{
		if(productList[i].getID() == find.value)
		{
			product = productList[i];
			break;
		}
	}
	
	if(!product)
	{
		alert("couldn't find product");
		return;
	}
	
	
	var eventSelect = getChildField(table.rows[eventRow], "FirstArgument");
	var event = product.getEvent(eventSelect.value);
	var eventFields = document.createElement("select");
	
	//add first 3 generic events to the list
	for(var i = 0; i < 4; i++)
	{
		//skip eventName
		if(i == 1)
		{
			continue;
		}
		option = document.createElement("option");
		option.innerHTML = product.genericFields[i];
		option.value = product.genericFields[i];
		eventFields.appendChild(option, false);
	}
	
	//add the other fields	
	for(var i = 2; i < event.length; i++)
	{
		option = document.createElement("option");
		if(event[i].length <= 0)
		{
			option.innerHTML = product.genericFields[i+2];
		}
		else
		{
			option.innerHTML = event[i];
		}
		option.value = product.genericFields[i+2];
		eventFields.appendChild(option, false);
	}
	
	//add sourceIP to the end of the select
	option = document.createElement("option");
	option.innerHTML = product.genericFields[product.genericFields.length-1];
	option.value = product.genericFields[product.genericFields.length-1];
	eventFields.appendChild(option, false);
	
	return eventFields;
}

function clearSelect(select)
{
	for(var i = select.options.length-1; i >= 0; i--)
	{
		select.options[i] = null;
	}
}

//looks in all previous rows for events
//only returns an event row if there is only one previous event
function getEventRow(table)
{
	var eventRow = -1;
	var eventCount = 0;
	for(var i = 0; i < table.rows.length; i++)
	{
		var select = getChildField(table.rows[i].cells[1], "Ignore");
		if(!select)
		{
			continue;
		}
		
		if(select.value == "<iman:string key="NAR_EVENTID_DISPLAY_NAME"/>")
		{
			//check for unknow product
			var pSelect = getChildField(table.rows[i].cells[3], "product");
			DebugOut("pSelect.value: " + pSelect.value);
			if(pSelect.value == -1)
			{
				continue;
			}
			
			eventRow = i;
			eventCount++;
		}
	}
	
	if(eventCount > 1 || eventCount < 1)
	{
		eventRow = -1;
	}
	
	return eventRow;
}

